@import "@/styles/variables";

.button {
    border: none;
    width: max-content;
    cursor: pointer;
    gap: 0.5rem;
    display: flex;
    justify-content: center;
    align-items: center;
    z-index: 2;

    &:disabled {
        cursor: not-allowed;
    }

    &-size_sm {
        height: 32px;
        padding: 10px 16px;
        border-radius: 0.5rem;

        @include button-3;
    }

    &-size_md {
        height: 40px;
        padding: 12px 20px;
        border-radius: 0.75rem;

        @include button-2;
    }

    &-size_lg {
        height: 58px;
        padding: 19px 24px;
        border-radius: 1rem;

        @include button-1;
    }

    // responsive button
    &-size_sm-md {
        height: 40px;
        padding: 12px 20px;
        border-radius: 0.75rem;

        @include button-3;

        @include tablet {
            height: 32px;
            padding: 10px 16px;
            border-radius: 0.5rem;
        }
    }

    &-size_md-lg {
        height: 58px;
        padding: 19px 24px;
        border-radius: 1rem;

        @include button-1;

        @include tablet {
            height: 40px;
            padding: 12px 20px;
            border-radius: 0.75rem;
        }
    }

    .label {
        font-family: var(--font-barlow);
        text-wrap: nowrap;
    }

    .icon-frame {
        display: flex;

        @include flex-center;

        &_sm {
            width: 0.75rem;
            height: 0.75rem;
        }

        &_md {
            width: 1rem;
            height: 1rem;
        }

        &_lg {
            width: 1.25rem;
            height: 1.25rem;
        }

        // responsive
        &_sm-md {
            width: 1rem;
            height: 1rem;

            @include tablet {
                width: 0.75rem;
                height: 0.75rem;
            }
        }

        &_md-lg {
            width: 1.25rem;
            height: 1.25rem;

            @include tablet {
                width: 1rem;
                height: 1rem;
            }
        }
    }

    .hide-label {
        display: none;

        @include tablet {
            display: flex;
        }

        &__tablet {
            @include tablet {
                display: none;
            }

            @include notebook {
                display: flex;
            }
        }
    }

    &-color_primary {
        background-color: $primary-color;
        color: $white;

        &:hover {
            background-color: $primary-color-hover;
        }

        &:active {
            background-color: $primary-color-active;
        }

        &:focus,
        &:focus-visible {
            background-color: $primary-color;
            outline: 1px solid $primary-color;

            @include shadow-focus;
        }

        &:disabled {
            background-color: $primary-color;
            opacity: 0.4;
        }
    }

    &-color_secondary {
        color: $white;
        background-color: $secondary-color;

        &:hover {
            background-color: $secondary-color-hover;
        }

        &:active {
            background-color: $secondary-color-active;
        }

        &:focus,
        &:focus-visible {
            background-color: $primary-color;
            outline: 1px solid $primary-color;

            @include shadow-focus;
        }

        &:disabled {
            background-color: $secondary-color;
            opacity: 0.4;
        }
    }

    &-color_tertiary {
        color: $gray-800;
        background-color: $tertiary-color;

        &:hover {
            background-color: $tertiary-color-hover;
        }

        &:active {
            background-color: $tertiary-color-active;
        }

        &:focus,
        &:focus-visible {
            background-color: $tertiary-color-active;
            outline: 1px solid $primary-color;

            @include shadow-focus;
        }

        &:disabled {
            background-color: $tertiary-color;
            opacity: 0.4;
        }
    }

    &-color_outline {
        color: $gray-800;
        border: 1px solid $tertiary-color;
        background-color: $white;

        &:disabled {
            opacity: 0.4;
        }

        &:hover {
            border: 1px solid $tertiary-color-hover;
        }

        &:active {
            border: 1px solid $tertiary-color-active;
        }

        &:focus,
        &:focus-visible {
            background-color: $tertiary-color-active;
            outline: 1px solid $primary-color;

            @include shadow-focus;
        }
    }

    &-color_link {
        color: $gray-800;
        background-color: transparent;

        &:disabled {
            opacity: 0.4;
        }

        &:focus,
        &:focus-visible {
            background-color: $gray-200;
            outline: 1px solid $primary-color;

            @include shadow-focus;
        }
    }

    &-square {
        border-radius: 0.75rem;
        padding: 1rem;
        aspect-ratio: 1;
    }

    &-circle {
        border-radius: 50%;
        padding: 0.5rem;
        aspect-ratio: 1;
    }
}
